<?php

/**
 * Webkul Software.
 *
 * @category  Webkul
 *
 * @author    Webkul Software Private Limited
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */

namespace Webkul\SalesforceConnector\Controller\Adminhtml\Categories;

use Webkul\SalesforceConnector\Helper\Category;

class Catdelete extends \Magento\Backend\App\Action
{
    /** @var \Magento\Framework\View\Result\PageFactory */
    protected $_resultPageFactory;
    protected $_helper;
    protected $dataProvider;
    /**
     * @var CollectionFactory
     */
    protected $_collectionFactory;

    /**
     * @param \Magento\Backend\App\Action\Context        $context
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Ui\Component\MassAction\Filter $filter,
        \Magento\Catalog\Model\ResourceModel\Category\CollectionFactory $collectionFactory,
        Category $helper
    ) {
        parent::__construct($context);

        $this->_resultPageFactory = $resultPageFactory;
        $this->_helper = $helper;
        $this->_filter = $filter;
        $this->_collectionFactory = $collectionFactory;
    }

    public function execute()
    {
        // if single id : using link
        $id = $this->getRequest()->getParam('entity_id');
        $recordDeleted = 0;
        if ($id) {
            $this->_helper->deleteMapping($id);
            ++$recordDeleted;
        } else {
            $ids = $this->getRequest()->getParam('selected');
            if ($ids) {
                if ($ids && count($ids) > 0) {
                    foreach ($ids as $id) {
                        $this->_helper->deleteMapping($id);
                        ++$recordDeleted;
                    }
                }
            } else {
                $excludedIds = $this->getRequest()->getParam('excluded');
                $collection = $this->_collectionFactory->create();
                $allCustomerIds = array();
                foreach ($collection->getItems() as $item) {
                    array_push($allCustomerIds, $item->getID());
                }
                if ($excludedIds == 'false') {

                    if ($allCustomerIds && count($allCustomerIds) > 0) {
                        foreach ($allCustomerIds as $id) {
                            $this->_helper->deleteMapping($id);
                            ++$recordDeleted;
                        }
                    }
                } else {
                    $ids = array_diff($allCustomerIds, $excludedIds);

                    if ($ids && count($ids) > 0) {
                        foreach ($ids as $id) {
                            $this->_helper->deleteMapping($id);
                            ++$recordDeleted;
                        }
                    }
                }
            }
        }
        //else {
        // in case sellect all or exclude some
        //TODO FIX: we can do only this block of code but this
        //will first fetch magento main category data
        //then passed to delete so to reduce db call.
        // In filter->getSelection it will get ids from
        //mapping table so only data matched in mapping
        //table is returned further if no data in mapping table
        //in(NUll) is used need fix.

        //check for excluded
        /*** */
        // $excluded = $this->getRequest()->getParam('excluded');
        // // we got magento id
        // $categoryCollection = $this->_objectManager->create('Magento\Catalog\Model\ResourceModel\Category\Collection');

        // if (is_array($excluded) && !empty($excluded)) {
        //     $categoryCollection->addFieldToFilter('entity_id', ['nin' => $excluded]);
        // }
        /*
             * internally _filter->getCollection will
             * initiate collectionFactory of $this i.e
             * category_mapping instead of categoryCollection
             * pased  hence filters are applied on mapping
             * table wich is not correct need fix.
             */
        // $collection = $this->_filter->getCollection($categoryCollection);

        // foreach ($collection->getItems() as $item) {
        //     $this->_helper->deleteMapping($item->getId());
        //     ++$recordDeleted;
        // }
        //}
        $this->messageManager->addSuccess(
            __('A total of %1 record(s) have been deleted.', $recordDeleted)
        );
        $resultRedirect = $this->resultRedirectFactory->create();
        $resultRedirect->setPath('sfconnector/categories/index/');

        return $resultRedirect;
    }
}
